<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml_idp\Form\MiniorangeSPInformation.
 */

namespace Drupal\miniorange_saml_idp\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\MiniorangeSAMLIdpConstants;
use Drupal\miniorange_saml_idp\Utilities;

class MiniorangeCustomCertificate extends FormBase
{

    public function getFormId()
    {
        return 'miniorange_custom_certificate';
    }

    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
    {

        global $base_url;

        Utilities::visual_tour_start($form, $form_state);

        $form['miniorange_saml_SP_tab_cert'] = array(
            '#prefix' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container">',
        );

        Utilities::visual_tour_start($form, $form_state);

        $form['miniorange_saml_idp_custom_cert_settings'] = array(
            '#markup' => '<h2>Add Custom Certificate </h2><hr><br/><div class = mo_saml_highlight_background_note><b>NOTE: </b>This tab will help you to save and generate new certificates.
                        You can perform following operations:<br><br> 1. Copy your own certificates and save them to use it for SSO.<br>
                        2. You can generate new certificates and use them for SSO.<br> 3. Reset setting to get back default settings.</div><br><br>',
        );

        $form['miniorange_saml_idp_private_certificate'] = array(
            '#type' => 'textarea',
            '#title' => t('X.509 Private Certificate.<b><a href="' . $base_url . MiniorangeSAMLIdpConstants::LICENSE_PAGE_URL . '"> [Premium]</a></b>'),
            '#cols' => 5,
            '#rows' => 5,
            '#attributes' => array('style' => 'width:700px;background-color: hsla(0,0%,0%,0.08) !important;', 'placeholder' => "Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=signing) in IdP-Metadata XML file."),
            '#disabled' => TRUE,
            '#description' => '<strong>NOTE :</strong> Format of the certificate:<br /><strong>-----BEGIN PRIVATE KEY-----<br />XXXXXXXXXXXXXXXXXXXXXXXXXXX<br />-----END PRIVATE KEY-----</strong><br /><br /><br />',
        );

        $form['miniorange_saml_idp_publ_certificate'] = array(
            '#type' => 'textarea',
            '#title' => t('X.509 Public Certificate <b><a href="' . $base_url . MiniorangeSAMLIdpConstants::LICENSE_PAGE_URL .'"> [Premium]</a></b>'),
            '#cols' => 5,
            '#rows' => 5,
            '#attributes' => array('style' => 'width:700px;background-color: hsla(0,0%,0%,0.08) !important;', 'placeholder' => "Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=signing) in IdP-Metadata XML file."),
            '#disabled' => TRUE,
            '#description' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b><br><br><br>',
        );

        $form['save_config_elements'] = array(
            '#type' => 'submit',
            '#name' => 'submit',
            '#value' => t('Upload'),
            '#prefix' => '<td>',
            '#suffix' => '</td>',
            '#disabled' => TRUE,
        );

        $form['save_config_elements1'] = array(
            '#type' => 'submit',
            '#value' => t('Reset'),
            '#disabled' => TRUE,
            '#prefix' => '<td>',
            '#suffix' => '</td></div>',
        );

        Utilities::spConfigGuide($form, $form_state);

        $form['markup_bottom'] = array(
            '#markup' =>'<div class="mo_saml_table_layout mo_saml_container"><h2>Generate Custom Certificate</h2><hr><br>
                         <div class="mo_saml_highlight_background_note"><b>Note:</b> Available in
                         <a href="' . $base_url . MiniorangeSAMLIdpConstants::LICENSE_PAGE_URL . '"> Premium</a> version of the module.</div>
                         <br>',
        );

        $form['mo_saml_country_code_text'] = array(
            '#type' => 'textfield',
            '#title' => 'Country Code:',
            '#description' => t('<b>NOTE: </b>Check your country code <a>here.</a>'),
            '#attributes' => array(
                'style' => 'width:700px;',
                'placeholder' => 'Enter Country code'
            ),
            '#disabled' => TRUE,
        );

        $form['mo_saml_certificate_state_name'] = array(
            '#type' => 'textfield',
            '#title' => 'State:',
            '#attributes' => array(
                'style' => 'width:700px; margin-bottom:12px;',
                'placeholder' => 'State Name'
            ),
            '#disabled' => TRUE,
        );

        $form['mo_saml_certificate_company_name'] = array(
            '#type' => 'textfield',
            '#title' => 'Company:',
            '#attributes' => array(
                'style' => 'width:700px; margin-bottom:12px;',
                'placeholder' => 'Company Name'
            ),
            '#disabled' => TRUE,
        );

        $form['miniorange_saml_unit_name'] = array(
            '#type' => 'textfield',
            '#title' => 'Unit:',
            '#attributes' => array(
                'style' => 'width:700px; margin-bottom:12px;',
                'placeholder' => 'Unit name'
            ),
            '#disabled' => TRUE,
        );

        $form['mo_saml_certificate_common_name'] = array(
            '#type' => 'textfield',
            '#title' => 'Common:',
            '#attributes' => array(
                'style' => 'width:700px; margin-bottom:12px;',
                'placeholder' => 'Common Name'
            ),
            '#disabled' => TRUE,
        );

        $form['mo_saml_select_digest_algo'] = array(
            '#type' => 'select',
            '#title' => 'Digest Algorithm:',
            '#options' => array(
                'sha512' => t('SHA512'),
                'sha384' => t('SHA384'),
                'sha256' => t('SHA256'),
                'sha1' => t('SHA1'),
            ),
            '#attributes' => array('style' => 'width:700px; margin-bottom:12px;'),
        );

        $form['mo_saml_select_private_key_bit'] = array(
            '#type' => 'select',
            '#title' => 'Bits to generate the private key:',
            '#options' => array(
                '2048' => t('2048 bits'),
                '1024' => t('1024 bits'),
            ),
            '#attributes' => array('style' => 'width:700px; margin-bottom:12px;'),
        );

        $form['mo_saml_select_valid_days'] = array(
            '#type' => 'select',
            '#title' => 'Valid Days:',
            '#options' => array(
                '365' => t('365 days'),
                '180' => t('180 days'),
                '90' => t('90 days'),
                '45' => t('45 days'),
                '30' => t('30 days'),
                '15' => t('15 days'),
                '7' => t('7 days'),
            ),
            '#attributes' => array('style' => 'width:700px; margin-bottom:12px;'),
            '#suffix' => '</td></tr></table>',
        );

        $form['generate_config_elements'] = array(
            '#type' => 'submit',
            '#value' => t('Generate Self-Signed Certs'),
            '#prefix' => '<td><br><br>',
            '#submit' => array('::miniorange_saml_generate_custom_certificate'),
            '#disabled' => TRUE,
        );

        $form['clear_genrate_certificate_data'] = array(
            '#type' => 'submit',
            '#value' => t('Clear Data'),
            '#submit' => array('::miniorange_saml_clear_genrate_certificate_data'),
            '#suffix' => '</td><br><br><br></div>',
            '#disabled' => TRUE,
        );

        Utilities::AddSupportButton($form, $form_state);

        return $form;
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
    {

    }
}
