<?php
/**
 * @file
 * Contains Licensing information for miniOrange SAML Login Module.
 */

/**
 * Showing Licensing form info.
 */
namespace Drupal\miniorange_saml_idp\Form;
use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\Utilities;

class MiniorangeLicensing extends FormBase {

    public function getFormId() {
        return 'miniorange_saml_licensing';
    }

    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
    {   
        global $base_url;
         $form['miniorange_saml_licensing_tab'] = array(
            '#attached' => array(
                'library' => array(
                  'miniorange_saml_idp/miniorange_saml_idp.register',
                )
            ),
        );

        $form['markup_1'] = array(
            '#markup' =>'<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout"><br><h3>&emsp;  UPGRADE PLANS</h3><hr>'
        );

        $form['markup_free'] = array(
            '#markup' => '<html lang="en">
        <head>
            <meta charset="utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1">
            <!-- Main Style -->
        </head>
        <body>
        <!-- Pricing Table Section -->
        <section id="mo_idp_pricing-table">
            <div class="mo_idp_container_1">
                <div class="row">
                    <div class="mo_idp_pricing">
                        <div>
                            <div class="mo_idp_pricing-table mo_idp_class_inline_1">
                                <div class="mo_idp_pricing-header">
                                    <h1 class="mo_idp_pricing-title">Features / Plans</h1></br>
                                </div>
                                <div class="mo_idp_pricing-list">
                                    <ul>
                                        <li>Unlimited Authentications with</li>
                                        <li>SP Initiated Login</li>
                                        <li>Signed Assertion</li>
                                        <li>Metadata XML File</li>
                                        <li>Metadata XML URL</li>
                                        <li>Export Configuration</li>                                        
                                        <li>Import Configuration</li>                                        
                                        <li>Customized Attribute Mapping</li>
                                        <li>Single Logout</li>
                                        <li>Signed Response</li>
                                        <li>Encrypted Assertion</li>
                                        <li>HTTP-POST Binding</li>
                                        <li>Generate Custom Certificate</li>
                                        <li>End to End Configuration **</li>
                                    </ul>
                                </div>
                        </div>
                                                     
                        <div class="mo_idp_pricing-table mo_idp_class_inline">
                            <div class="mo_idp_pricing-header">
                                <p class="mo_idp_pricing-title">Free</p><br><br><br><br><br><br>
                                <p class="mo_idp_pricing-rate">                                                                      
                                </p>
                                <div class="mo_idp_filler-class"></div>
                                 <a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" style="padding:5px;">You are on this plan</a> <br><br>                                
                            </div>
                            
                            <div class="mo_idp_pricing-list">
                                <ul>
                                    <li>1 SP</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li></li>
                                    <li></li>
                                    <li></li>
                                    <li></li>
                                    <li></li>
                                    <li></li>
                                    <li></li>
                                    <li></li>
                                </ul>
                            </div>
                        </div>
                        
                        <div class="mo_idp_pricing-table mo_idp_class_inline">
                            <div class="mo_idp_pricing-header">
                                <p class="mo_idp_pricing-title">DO IT YOURSELF<br></p>    
                                <p class="mo_idp_pricing-rate"></p>
                                <div class="mo_idp_filler-class"></div><br>
                                <p id="yourself" hidden>\'' . self::miniorange_saml_doityourself_button(). '\'</p>
                                 <a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" style="padding:5px;" id="you">Click here to upgrade</a>*<br><br></h4>
                            </div>
                            <div class="mo_idp_pricing-list">
                                <ul>
                                    <li>Multiple SPs*</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li></li>                                    
                                </ul>
                            </div>
                        </div>
                        
                        <div class="mo_idp_pricing-table mo_idp_class_inline">
                            <div class="mo_idp_pricing-header">
                                <p class="mo_idp_pricing-title">Premium<br></p>
                                <p class="mo_idp_pricing-rate"></p><br>
                                <p id="premium" hidden>\'' . self::miniorange_saml_premium_button(). '\'</p>
                                 <a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" id="prem" style="padding:5px;" >Click here to upgrade</a>*<br><br></h4>
                            </div>
                            <div class="mo_idp_pricing-list">
                                <ul>                                  
                                    <li>Multiple SPs*</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                </ul>
                            </div>
                        </div>                                                                     
                    </div>
                </div>
            </div>
        </div>
    </section>
    <!-- Pricing Table Section End -->
    </body>
    </html>',
        );

        $form['hello1'] = [ '#type' => 'html_tag', '#tag' => 'script', '#attributes'=> ["src"=>"https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"]];

        $form['hello'] = [ '#type' => 'html_tag', '#tag' => 'script', '#value' => $this ->t('
            jQuery(document).ready(function($){
                $($("p.mo_idp_pricing-rate")[1]).append($(".js-form-item-mo-pricing-dropdown"));
                $($("p.mo_idp_pricing-rate")[1]).append($(".mo_pricing_plus_sign"));
                $($("p.mo_idp_pricing-rate")[1]).append($(".js-form-item-do-it-yourself-pricing"));
            }); 
        '), ];

        $form['mohello'] = [ '#type' => 'html_tag', '#tag' => 'script', '#value' => $this ->t('
            jQuery(document).ready(function($){
                $($("p.mo_idp_pricing-rate")[2]).append($(".js-form-item-mo-pricing-dropdown-2"));
                $($("p.mo_idp_pricing-rate")[2]).append($(".mo_pricing_plus_sign_2"));
                $($("p.mo_idp_pricing-rate")[2]).append($(".js-form-item-do-it-yourself-pricing-2"));
            }); 
        '), ];

        $form['mo_pricing_dropdown'] = [
            '#type' => 'select',
            '#title' => t('<div class="mo_saml_local_pricing_text">Service Providers :(One Time)</div>'),
            '#options' => array(
                '1' => t('1 - $50'),
                '2' => t('2 - $100'),
                '3' => t('3 - $150'),
                '4' => t('4 - $200'),
                '5' => t('5 - $250'),
                '10' => t('10 - $400'),
                '15' => t('15 - $525'),
                '20' => t('20- $600'),
            ),

        ];

        $form['mo_pricing_plus_sign'] = array(
            '#markup' => '<br><div class="mo_pricing_plus_sign">+</div>',
        );

        $form['Do_it_yourself_pricing'] = array(
            '#type' => 'select',
            '#title' => t('<div class="mo_saml_local_pricing_text">Users : (Per Year)</div>'),
            '#options' => array(
                '200' => t('200 - $99'),
                '400' => t('400 - $199'),
                '600' => t('600 - $249'),
                '800' => t('800 - $299'),
                '1000' => t('1000 - $349'),
                '2000' => t('2000 - $449'),
                '3000' => t('3000 - $549'),
                '4000' => t('4000 - $649'),
                '5000' => t('5000 - $749'),
                '5000+' => t('5000+ Users - Contact Us'),
            ),
        );

        $form['mo_pricing_dropdown_2'] = [
            '#type' => 'select',
            '#title' => t('<div class="mo_saml_local_pricing_text">Service Providers :(One Time)</div>'),
            '#options' => array(
                '1' => t('1 - $50'),
                '2' => t('2 - $100'),
                '3' => t('3 - $150'),
                '4' => t('4 - $200'),
                '5' => t('5 - $250'),
                '10' => t('10 - $400'),
                '15' => t('15 - $525'),
                '20' => t('20- $600'),
            ),
        ];

        $form['mo_pricing_plus_sign_2'] = array(
            '#markup' => '<div class="mo_pricing_plus_sign_2">+</div>',
        );

        $form['Do_it_yourself_pricing_2'] = array(
            '#type' => 'select',
            '#title' => t('<div class="mo_saml_local_pricing_text">Users : (Per Year)</div>'),
            '#options' => array(
                '200' => t('200 - $99'),
                '400' => t('400 - $199'),
                '600' => t('600 - $249'),
                '800' => t('800 - $299'),
                '1000' => t('1000 - $349'),
                '2000' => t('2000 - $449'),
                '3000' => t('3000 - $549'),
                '4000' => t('4000 - $649'),
                '5000' => t('5000 - $749'),
                '5000+' => t('5000+ Users - Contact Us'),
            ),
        );

        $form['markup_5'] = array(
            '#markup' => '</b><br><div class="mo_saml_space"><h3>Steps to Upgrade to Premium Module</h3>'
                . '<ol>
                <li>After clicking on <b>Click here to upgrade</b> button you will be redirected to miniOrange Login Console. Enter your password with which you created an account with us. After that you will be redirected to payment page.</li>'
                . '<li>Enter your card details and complete the payment. On successful payment completion, you will see the link to download the premium module.</li>'
                . 'Once you download the premium module, just unzip it and replace the folder with existing module.'
                . '<li>After the module is installed clear the Drupal cache by clicking on <b><i>Clear all caches</i></b> <a href = "' . $base_url . '/admin/config/development/performance" target = "_blank">here.</a></li>
                </ol><br>'
        );

        $form['markup_6'] = array(
            '#markup' => '<h3>* Multiple SPs</h3>'
            .'Additional charges will be applicable based on the number of Service Providers you wish to configure.<br>'
        );
        $form['markup_7'] = array(
            '#markup' => '<br><h3>** End to End Identity Provider Integration (additional charges applied)</h3>'
                . ' We will setup a Conference Call / Gotomeeting and do end to end configuration for you to setup dupal as IDP.'
                . ' We provide services to do the configuration on your behalf.<br />'
                . ' If you have any doubts regarding the licensing plans, you can mail us at <a href="mailto:drupalsupport@xecurify.com"><i>drupalsupport@xecurify.com</i></a> or submit a query using the support button available on each tab.<br><br></div></div></div></div>'
        );
        return $form;
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

    }


    function miniorange_saml_doityourself_button(){
        $admin_email = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email');
        $admin_email = (isset($admin_email) && !empty($admin_email)) ? $admin_email : 'none';
        $DoItYourSelf_URL_Redirect = 'https://login.xecurify.com/moas/login?username='.$admin_email.'&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=drupal_saml_idp_basic_plan_v8';
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('redirect_plan_after_registration_doityourself',$DoItYourSelf_URL_Redirect)->save();

        return self::return_url($DoItYourSelf_URL_Redirect, 'doityourself');
    }

    function miniorange_saml_premium_button(){
        $admin_email = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email');
        $admin_email = (isset($admin_email) && !empty($admin_email)) ? $admin_email : 'none';
        $Premium_URL_Redirect = 'https://login.xecurify.com/moas/login?username='.$admin_email.'&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=drupal_saml_idp_premium_plan_v8';
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('redirect_plan_after_registration_premium',$Premium_URL_Redirect)->save();
        return self::return_url($Premium_URL_Redirect, 'premium');
    }

    function return_url($url, $payment_plan){
        if(Utilities::isCustomerRegistered()){
            return $url;
        }else{
            global $base_url;
            $SAMLrequestUrl = $base_url . '/register_user/?payment_plan=' . $payment_plan;
            return $SAMLrequestUrl;
        }
    }

}

