<?php
/**
 * @file
 * Contains Request for Demo information for miniOrange SAML Login Module.
 */

namespace Drupal\miniorange_saml_idp\Form;
use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\Utilities;

class MiniorangeRequestDemo extends FormBase {

    public function getFormId() {
        return 'miniorange_request_demo';
    }

    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $user_email = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email');
        Utilities::visual_tour_start($form, $form_state);

        $form['markup_1'] = array(
            '#markup' =>'<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container">
                        <h2>Request for demo</h2><hr><br>'
        );

        $form['markup_2'] = array(
            '#markup' => '<div class="mo_saml_highlight_background_note_export"><p><strong>Want to test the premium module before purchasing? </strong></p>
                          <p>Just send us a request, We will setup a demo site for you on our cloud with the premium module and provide you with the administrator credentials.
                          You can configure it with your service provider and test all the premium features as per your requirement.</p>  
                          </div><br>',
        );

        $form['customer_email'] = array(
            '#type' => 'email',
            '#title' => t('Email<span style="color: red">*</span>'),
            '#default_value' => t(strval($user_email)),
            '#attributes' => array('style' => 'width:65%;', 'placeholder' => 'Enter your email'),
            '#description' => t('<b>Note:</b> Use valid EmailId. ( We discourage the use of disposable emails )'),
        );

        $form['demo_plan'] = array(
            '#type' => 'textfield',
            '#title' => t('Demo Plan'),
            '#attributes' => array('style' => 'width:65%;'),
            '#value' => t('Drupal 8 SAML IDP Premium'),
            '#disabled' => TRUE,
        );

        $form['description_doubt'] = array(
            '#type' => 'textarea',
            '#title' => t('Description<span style="color: red">*</span>'),
            '#attributes' => array('style' => 'width:65%', 'placeholder' => 'Describe your requirement'),
        );

        $form['submit_button'] = array(
            '#type' => 'submit',
            '#value' => t('Submit'),
            '#prefix' => '<br>',
            '#suffix' => '<br><br></div>',
        );

        Utilities::spConfigGuide($form, $form_state);
        Utilities::AddSupportButton($form, $form_state);
        return $form;
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $email = $form['customer_email']['#value'];
        $demo_plan = $form['demo_plan']['#value'];
        $description_doubt = $form['description_doubt']['#value'];
        $query = $demo_plan.' -> '.$description_doubt;
        $phone = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_phone');

        Utilities::send_support_query($email, $phone, $query, TRUE);
    }
}